<template>
  <v-autocomplete
    v-model="select"
    v-bind="$attrs"
    :loading="loading"
    :items="items"
    :search-input.sync="search"
    :item-text="itemText"
    :item-value="itemValue"
    @focus="updateItems"
  />
</template>

<script>
export default {
  name: "RelationInput",
  props: {
    value: {
      type: [String, Array]
    },
    endpoint: {
      type: String,
      default: ""
    },
    itemText: {
      type: [String, Function],
      default: ""
    },
    itemValue: {
      type: String,
      default: ""
    },
    params: {
      type: Object,
      default: () => ({})
    }
  },
  data() {
    return {
      loading: false,
      items: [],
      search: null,
      loaded: false
    };
  },
  computed: {
    select: {
      get() {
        return this.value;
      },
      set(v) {
        this.$emit("input", v);
      }
    }
  },
  watch: {
    async endpoint() {
      this.$emit("input", "");
      this.items = await this.getItems();
    },
    value: {
      async handler(v) {
        if (
          !v ||
          (Array.isArray(v) &&
            (v.length === 0 ||
              v.every(itemId =>
                this.items.some(item => item[this.itemValue] === itemId)
              ))) ||
          (!Array.isArray(v) &&
            this.items.some(item => item[this.itemValue] === v))
        )
          return;
        let filter = {};

        if (Array.isArray(v)) {
          filter = {
            where: {
              [this.itemValue]: { inq: v }
            }
          };
        } else {
          filter = {
            where: {
              [this.itemValue]: v
            }
          };
        }

        const response = await this.$axios.get(this.endpoint, {
          params: {
            filter
          }
        });

        if (Array.isArray(v)) {
          this.items = response.data;
        } else {
          this.items.push(response.data[0]);
        }
      },
      immediate: true
    }
  },
  methods: {
    async updateItems() {
      if (this.loaded) return;
      this.items = await this.getItems();
    },
    async getItems() {
      const response = await this.$axios.get(this.endpoint, {
        params: this.params
      });
      this.loaded = true;
      return response.data;
    }
    /*  async querySelections(v) {
        this.loading = true;
        const response = await this.$axios.get(this.endpoint, {
          params: {
            filter: {
              where: {
                [this.itemText]: {
                  like: v,
                  options: "i"
                }
              }
            }
          }
        });
        this.items = response.data;
        this.loading = false;
      } */
  }
};
</script>
